#include <linux/module.h>
#include <linux/cpu.h>
#include <linux/init.h>
#include <linux/ioctl.h>
#include <linux/uaccess.h>
#include <linux/fs.h>
#include <linux/slab.h>
#include <linux/cpumask.h>
#include <linux/miscdevice.h>

static void write_cpuid(void *arg)
{
	u64 cpu = smp_processor_id();
	u64 node = numa_node_id();

	cpu = (node << 8) | cpu;

	pr_info("cpu %llx, node %2d\n", cpu, node);

	write_sysreg(cpu, S3_3_c15_c3_1);
}

static int __init getcpu_init(void) {

	on_each_cpu(write_cpuid, NULL, 1);

	return 0;
}

static void __exit getcpu_exit(void) {

}

module_init(getcpu_init);
module_exit(getcpu_exit);
MODULE_LICENSE("GPL");
MODULE_AUTHOR("wxf");
